package dbc.r15.sample.b4xxntjr;

import java.nio.ByteBuffer;

public class AccRqstAreaWrapper {
	private final int[] ACC_BUFFER = {0, 256};
	private final int[] ACC_CMD = {0, 5};
	private final int[] ACC_TBLNM = {5, 3};
	private final int[] ACC_KEYNM = {8, 5};
	private final int[] ACC_RC = {13, 2};
	private final int[] ACC_IRC = {15, 1};
	private final int[] ACC_DBID = {16, 2};
	private final int[] ACC_TBLID = {18, 2};
	private final int[] ACC_RECID = {20,5};
	private final int[] ACC_FILLER1 = {25, 51};
	private final int[] ACC_KEY_VALUE = {76, 180};
	private final int[] ACC_KEY_BID = {76, 9};
	private final int[] ACC_KEY_AID = {85, 9};
	private final int[] ACC_FILLER2 = {94, 162};
	 
		// Variable to hold the binary data in the container
		private byte[] arData;
		// Set the binary value of the container
		public void setByteArray(byte[] data) { arData = data;}
		// Get the binary value of the container
		public byte[] getByteArray() {return arData;}
		// 
		public void setCommand(String newValue) {setNewValue(newValue, ACC_CMD[0], ACC_CMD[1]);
		}
		public String getCommand() {return new String(arData,ACC_CMD[0], ACC_CMD[1]);
			}
		public void setTableName(String newValue) {setNewValue(newValue, ACC_TBLNM[0], ACC_TBLNM[1]);
		}
		public String getTableName() {return new String(arData,ACC_TBLNM[0], ACC_TBLNM[1]);
			}
		public void setKeyName(String newValue) {setNewValue(newValue, ACC_KEYNM[0], ACC_KEYNM[1]);
		}
		public String getKeyName() {return new String(arData,ACC_KEYNM[0], ACC_KEYNM[1]);
			}
		public void setReturnCode(String newValue) {setNewValue(newValue, ACC_RC[0], ACC_RC[1]);
		}
		public String getReturnCode() {return new String(arData,ACC_RC[0], ACC_RC[1]);
			}
		public void setiReturnCode(String newValue) {setNewValue(newValue, ACC_IRC[0], ACC_IRC[1]);
		}
		public String getiReturnCode() {return new String(arData,ACC_IRC[0], ACC_IRC[1]);
			}
		public void setDbid(short newValue) {setShortNewValue(newValue, ACC_DBID[0], ACC_DBID[1]);
		}
		public String getDbid() {return new String(arData,ACC_DBID[0], ACC_DBID[1]);
			}
		public void setTblid(String newValue) {setNewValue(newValue, ACC_TBLID[0], ACC_TBLID[1]);
		}
		public String getTblid() {return new String(arData,ACC_TBLID[0], ACC_TBLID[1]);
			}
		public void setRecid(String newValue) {setNewValue(newValue, ACC_RECID[0], ACC_RECID[1]);
		}
		public String getRecid() {return new String(arData,ACC_RECID[0], ACC_RECID[1]);
			}
		public void setKeyValue(String newValue) {setNewValue(newValue, ACC_KEY_VALUE[0], ACC_KEY_VALUE[1]);
		}
		public String getKeyValue() {return new String(arData,ACC_KEY_VALUE[0], ACC_KEY_VALUE[1]);
			}
		public void setKeyBid(String newValue) {setNewValue(newValue, ACC_KEY_BID[0], ACC_KEY_BID[1]);
		}
		public String getKeyBid() {return new String(arData,ACC_KEY_BID[0], ACC_KEY_BID[1]);
			}
		public void setKeyAid(String newValue) {setNewValue(newValue, ACC_KEY_AID[0], ACC_KEY_AID[1]);
		}
		public String getKeyAid() {return new String(arData,ACC_KEY_AID[0], ACC_KEY_AID[1]);
			}
         
        /* Inserts a value into the main byte[] and pads with spaces if necessary.
    	 * Note: values will be left justified
    	 */
    	private void setNewValue(String newValue, int index, int length) {
    		/* 1. create a new byte array to hold the string called tData for temporary data
    		 * 2. copy the new tData byte array to the cData byte array one byte at a time
    		 * 3. pad the cData with spaces up to the length passed in on the call 
    		 */
    		byte tData[] = newValue.getBytes();		// .step 1.
    		int tDatalen = tData.length;
    		int cDatalen = arData.length;
    		int i = 0;
    		while ( i < length && index < cDatalen)
    		{
    			if ( i < tDatalen )
    				arData[index++] = tData[i];
    			else
    				arData[index++] = 0x40;			
    			i++;
    		}
    	}
    		private void setShortNewValue(short newValue, int index, int length) {
    		/**** Important : We converted a 4-character field (string with a value of 0400)  
       		 to short using urs = Short.valueOf(caW.getDbid()); then came here with the short
       		 object and initialized the two byte DBID with this value       		 ****/
    			ByteBuffer buffer = ByteBuffer.allocate(2);
    			buffer.putShort(newValue);
    			buffer.flip();
    			
        		byte tData[] = buffer.array();		// .step 1.
        		int tDatalen = tData.length;
        		int cDatalen = arData.length;
        		int i = 0;
        		while ( i < length && index < cDatalen)
        		{
        			if ( i < tDatalen )
        				arData[index++] = tData[i];
        			else
        				arData[index++] = 0x00;			
        			i++;
        		}

}
}
