package dbc.r15.sample.b4xxntju;
import java.nio.ByteBuffer;

public class RqstAreaWrapperU {

private final int[] RQ_BUFFER = {0, 256};
private final int[] RQ_CMD = {0, 5};
private final int[] RQ_TBLNM = {5, 3};
private final int[] RQ_KEYNM = {8, 5};
private final int[] RQ_RC = {13, 2};
private final int[] RQ_IRC = {15, 1};
private final int[] RQ_DBID = {16, 2};
private final int[] RQ_TBLID = {18, 2};
private final int[] RQ_RECID = {20,5};
private final int[] RQ_FILLER1 = {25, 51};
private final int[] RQ_KEY_VALUE = {76, 132};   // should be 180 but TDQ would throw exception
private final int[] RQ_KEY_BID = {76, 9};
private final int[] RQ_KEY_TEL = {76, 9};
private final int[] RQ_KEY_BRN = {76, 9};
private final int[] RQ_KEY_AID = {85, 9};
private final int[] RQ_FILLER2 = {94, 162};
 
	// Variable to hold the binary data in the container
	private byte[] rqData;
	// Set the binary value of the container
	public void setByteArray(byte[] data) { rqData = data;}
	// Get the binary value of the container
	public byte[] getByteArray() {return rqData;}
	// 
	public void setCommand(String newValue) {setNewValue(newValue, RQ_CMD[0], RQ_CMD[1]);
	}
	public String getCommand() {return new String(rqData,RQ_CMD[0], RQ_CMD[1]);
		}
	public void setTableName(String newValue) {setNewValue(newValue, RQ_TBLNM[0], RQ_TBLNM[1]);
	}
	public String getTableName() {return new String(rqData,RQ_TBLNM[0], RQ_TBLNM[1]);
		}
	public void setKeyName(String newValue) {setNewValue(newValue, RQ_KEYNM[0], RQ_KEYNM[1]);
	}
	public String getKeyName() {return new String(rqData,RQ_KEYNM[0], RQ_KEYNM[1]);
		}
	public void setReturnCode(String newValue) {setNewValue(newValue, RQ_RC[0], RQ_RC[1]);
	}
	public String getReturnCode() {return new String(rqData,RQ_RC[0], RQ_RC[1]);
		}
	public void setiReturnCode(String newValue) {setNewValue(newValue, RQ_IRC[0], RQ_IRC[1]);
	}
	public String getiReturnCode() {return new String(rqData,RQ_IRC[0], RQ_IRC[1]);
		}
	public void setDbid(short newValue) {setShortNewValue(newValue, RQ_DBID[0], RQ_DBID[1]);
	}
	public String getDbid() {return new String(rqData,RQ_DBID[0], RQ_DBID[1]);
		}
	public void setTblid(String newValue) {setNewValue(newValue, RQ_TBLID[0], RQ_TBLID[1]);
	}
	public String getTblid() {return new String(rqData,RQ_TBLID[0], RQ_TBLID[1]);
		}
	public void setRecid(String newValue) {setNewValue(newValue, RQ_RECID[0], RQ_RECID[1]);
	}
	public String getRecid() {return new String(rqData,RQ_RECID[0], RQ_RECID[1]);
		}
	public void setKeyValue(String newValue) {setNewValue(newValue, RQ_KEY_VALUE[0], RQ_KEY_VALUE[1]);
	}
	public String getKeyValue() {return new String(rqData,RQ_KEY_VALUE[0], RQ_KEY_VALUE[1]);
		}
	public void setKeyBid(String newValue) {setNewValue(newValue, RQ_KEY_BID[0], RQ_KEY_BID[1]);
	}
	public String getKeyBid() {return new String(rqData,RQ_KEY_BID[0], RQ_KEY_BID[1]);
		}
	public void setKeyTel(String newValue) {setNewValue(newValue, RQ_KEY_TEL[0], RQ_KEY_TEL[1]);
	}
	public String getKeyTel() {return new String(rqData,RQ_KEY_TEL[0], RQ_KEY_TEL[1]);
		}
	public void setKeyBrn(String newValue) {setNewValue(newValue, RQ_KEY_BRN[0], RQ_KEY_BRN[1]);
	}
	public String getKeyBrn() {return new String(rqData,RQ_KEY_BRN[0], RQ_KEY_BRN[1]);
		}
	public void setKeyAid(String newValue) {setNewValue(newValue, RQ_KEY_AID[0], RQ_KEY_AID[1]);
	}
	public String getKeyAid() {return new String(rqData,RQ_KEY_AID[0], RQ_KEY_AID[1]);
		}
     
    /* Inserts a value into the main byte[] and pads with spaces if necessary.
	 * Note: values will be left justified
	 */
	private void setNewValue(String newValue, int index, int length) {
		/* 1. create a new byte array to hold the string called tData for temporary data
		 * 2. copy the new tData byte array to the cData byte array one byte at a time
		 * 3. pad the cData with spaces up to the length passed in on the call 
		 */
		byte tData[] = newValue.getBytes();		// .step 1.
		int tDatalen = tData.length;
		int cDatalen = rqData.length;
		int i = 0;
		while ( i < length && index < cDatalen)
		{
			if ( i < tDatalen )
				rqData[index++] = tData[i];
			else
				rqData[index++] = 0x40;			
			i++;
		}
	}
		private void setShortNewValue(short newValue, int index, int length) {
			/**** Important : We converted a 4-character field (string with a value or 0400)  
   		 and converted it to short using urs = Short.valueOf(caW.getDbid()); then came
   		 here with the short object and initialized the two byte DBID with this value
   		 ****/
			ByteBuffer buffer = ByteBuffer.allocate(2);
			buffer.putShort(newValue);
			buffer.flip();
			
    		byte tData[] = buffer.array();		// .step 1.
    		int tDatalen = tData.length;
    		int cDatalen = rqData.length;
    		int i = 0;
    		while ( i < length && index < cDatalen)
    		{
    			if ( i < tDatalen )
    				rqData[index++] = tData[i];
    			else
    				rqData[index++] = 0x00;			
    			i++;
    		}
		}
}
