package dbc.r15.sample.dccjcpr;

public class RqstAreaWrapper {
	private final int[] PMF_RQST_BUFFER = {0, 83};
	private final int[] PAY_RQST_BUFFER = {0, 81};
	private final int[] RQST_COMMAND = {0, 5};
	private final int[] RQST_FILENAME = {5, 3};
	private final int[] RQST_KEYNAME = {8, 5};
	private final int[] RQST_RETURNCODE = {13, 2};
	private final int[] RQST_RECORDID = {15, 1};
	private final int[] RQST_DBID = {16, 2};
	private final int[] RQST_RESERVEONE = {18, 7};
	private final int[] RQST_ACTIVITYCODE = {25, 1};
	private final int[] RQST_RESERVETWO = {26, 50};
	private final int[] RQST_KEYVALUE = {76, 5};
	private final int[] RQST_STATECODE = {76, 2};
	private final int[] RQST_ZIPCODE = {78, 5};
	 
	// Variable to hold the binary data in the container 
	 
	private byte[] cData;
	 
	// Instantiate the Wrapper object and initialize it values
	 
	// public PmfRqstContWrapper() {
	//	cData = new byte[RQST_BUFFER[1]];
	//	setNewValue(" ", 0, cData.length);
	// }
	
	 /* Set the binary data of container */
	public void setByteArray(byte[] data) { cData = data;}
	 
	/* Get the binary data of the container */
	public byte[] getByteArray() {return cData;}
	 

	/* Set the value of ActivityCode */
	public void setCommand(String newValue) {setNewValue(newValue, RQST_COMMAND[0], RQST_COMMAND[1]);
	}
	/* Get the value of RQST_COMMAND
	 */
	public String getCommand() {return new String(cData, RQST_COMMAND[0], RQST_COMMAND[1]);
	}
	/* Set the value of ActivityCode */
	public void setActivityCode(String newValue) {setNewValue(newValue, RQST_ACTIVITYCODE[0], RQST_ACTIVITYCODE[1]);
	}
	/* Get the  value of return code */
	public String getReturnCode() {return new String(cData, RQST_RETURNCODE[0], RQST_RETURNCODE[1]);
	}
	/* Get the value of RQST_ACTIVITYCODE */
	public String getActivityCode() {return new String(cData, RQST_ACTIVITYCODE[0], RQST_ACTIVITYCODE[1]);
//	byte[] b = toByteArray(cData, RQST_ACTIVITYCODE[0], RQST_ACTIVITYCODE[1]);
	}
	public void setKeyValue(String newValue) {setNewValue(newValue, RQST_KEYVALUE[0], RQST_KEYVALUE[1]);
	}
	 
	/* Inserts a value into the main byte[] and pads with spaces if necessary.
	 * Note: values will be left justified
	 */
	private void setNewValue(String newValue, int index, int length) {
		/* 1. create a new byte array to hold the string called tData for temporary data
		 * 2. copy the new tData byte array to the cData byte array one byte at a time
		 * 3. pad the cData with spaces up to the length passed in on the call 
		 */
		byte tData[] = newValue.getBytes();		// .step 1.
		int tDatalen = tData.length;
		int cDatalen = cData.length;
		int i = 0;
		while ( i < length && index < cDatalen)
		{
			if ( i < tDatalen )
				cData[index++] = tData[i];
			else
				cData[index++] = 0x40;			
			i++;
		}
		

	}
	

}
